\chapter{Conclusion}\label{conclusion}
In this project, we examined the performance of a decentralized machine learning system when put through different communication techniques and various model-sharing methods. We observed the performance of D-PSGD and RWM algorithms used for communication and local model updates executed on three different datasets. Those datasets, namely MovieLens Latest, CelebA, and FEMNIST, cover both recommendation and classification systems, where machine learning algorithms used are matrix factorization and convolutional neural networks. Additionally, which model parameters the nodes exchanged among themselves and how much is varied through a couple of sharing methods.
\\

We observed how usually sharing model parameters with all the neighbors and updating the local model using Metropolis-Hastings weight averaging, i.e., using D-PSGD, yields better results. When experimenting with a recommendation dataset, we conclude that the differences between the two approaches are almost negligible. However, the same can not be said for the image classification dataset CelebA, which consistently produced a better performance using the D-PSGD model. For the FEMNIST dataset, the line is blurry, but the D-PSGD still outperforms. Hence, the impact can also be found in model size and its nature. All this is concluded based on machine learning model accuracy or evaluation loss. Furthermore, the results remain the same when measuring the total processing time a run takes, meaning that time does not represent a significant burden. In contrast, we have an important trade-off for the two algorithms in terms of network load. As the RWM has less communication and computations, the amount of data exchanged is considerably less. Hence, a random walk model would produce a far better model if we were to limit the system's network traffic.

\section{Future Work}
This research can be further extended; hence, we present some ideas for future implementations. One direction of development lies in coming up with a different approach to sending information and updating the model in the RWM algorithm. For instance, a node can periodically send its model parameters to a randomly chosen neighbor, which would increase the pace of node advancement to further rounds and possibly lead to better performance. Additional work can be applied to mixing the two communication techniques to achieve the best possible performance without overloading the network. Since we have observed in a few experiments patterns that indicate better RWM performance only at the start of a run, it might be useful to create a system that would behave as an RWM at the beginning and then change to using the D-PSGD approach. Also, there should be more research regarding the performance of the methods on different network topologies. Since one of the algorithms is randomized, the performance might significantly differ based on the number of nodes in the network and how they are connected.
